#include "Main.h"
#include "Collision.h"
#include "Player.h"
#include "Anim.h"
#include "JoyPad.h"

CJoyPad JoyPad;

CPlayer::CPlayer(CGameMain* game) 
	:CMover(0,0,-8,-8,8,8),Dir(0),GroundFlag(false),JumpCount(0){
	Game = game;
	Game->SetPlayer(this);
	POINT pt[] =
	{
		{ (LONG)L,	(LONG)T },//
		{ 0,			(LONG)T },//^
		{ (LONG)R,	(LONG)T },//E

		{ (LONG)L,	0 },//^
		{ (LONG)R,	0 },//E^

		{ (LONG)L,	(LONG)B },//
		{ 0,			(LONG)B },//^
		{ (LONG)R,	(LONG)B },//E
	};
	ColObj = new CCollision(pt, 0, 0, 0, 0, 0,Game);

	CMotion temp[MOTION_MAX][ANIMATION_MAX] = {
		//ォ珇STAND,WALK,JUMP,LAND
		{{0,3},{1,3},{2,3},{1,3},{0,3}, {MLOOP,0}},
	};
	int col = sizeof(temp) / sizeof(temp[0]);
	int row = sizeof(temp[0]) / sizeof(temp[0][0]);
}

CPlayer::CPlayer(float x, float y, CGameMain* game)
	:CMover(x, y, -8, -8, 8, 8),Dir(0) {
	Game = game;
	Game->SetPlayer(this);
	POINT pt[] =
	{
		{ (LONG)L,	(LONG)T },//
		{ 0,			(LONG)T },//^
		{ (LONG)R,	(LONG)T },//E

		{ (LONG)L,	0 },//^
		{ (LONG)R,	0 },//E^

		{ (LONG)L,	(LONG)B },//
		{ 0,			(LONG)B },//^
		{ (LONG)R,	(LONG)B },//E
	};
	ColObj = new CCollision(pt, 0, 0, 0, 0, 0, Game);
}

void CPlayer::SetPlayer(float* x, float* y) {
	X = *x;
	Y = *y;
}

CPlayer::~CPlayer(){
	delete ColObj;
}

bool CPlayer::Move() {
	JoyPad.Update();
	if (JoyPad.Get(PAD_INPUT_LEFT)) {
		VX = -3.0F;
		Dir = 1;
	}
	else if (JoyPad.Get(PAD_INPUT_RIGHT)) {
		VX = 3.0F;
		Dir = 0;
	}
	else {
		VX = 0;
	}

	//XWɈړʂB
	X += VX;

	ColObj->GetMove(&X, &Y, &JumpCount, &GroundFlag);

	//Wṽt[mہB
	if (JoyPad.Get(PAD_INPUT_1)) {
		JBFrame++;
	}
	else {
		JBFrame = 0;
	}

	if (!GroundFlag) {
		if (VY > GRAVMAX)
		{
			VY = GRAVMAX;
		}
		else
		{
			VY += GRAV;
		}
	}
	else {
		VY = 0;
	}


	//YWɈړʂB
	Y += VY;

	//Wv
	if (JoyPad.Get(PAD_INPUT_1) && JumpCount < 5) {
		if (JumpCount < 1 && GroundFlag) {
			JumpCount++;
			VY = -9.0F;
		}
	}

	return true;
}

void CPlayer::Draw() {
	DrawRotaGraph((int)X, (int)Y, 1.0, 0, Game->GetPlayerGh(0), TRUE, Dir);
}